
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>《深入理解Java虚拟机》笔记04 -- 并发锁 / 憋错料</title>

    <meta name="description" content="《深入理解Java虚拟机》笔记04 -- 并发锁 Java虚拟机在操作系统层面会先尽一切可能在虚拟机层面上解决竞争关系,尽可能避免真实的竞争发生.同时,在竞争不激烈的场合,也会试图消除不必要的竞争.实现这些手段的方法包括:偏向锁.轻量级锁.自旋锁.锁消除.锁膨胀等 1. 偏向锁 偏向锁是JDK1.6提出的一种锁优化方式.其核心思想是:如果程序没有竞争,则取消之前已经取得锁的线程同步操作.也就是说,若某一锁被线程获取后,便进入偏向模式,当线程再次请求这个锁时,无需再进行相关的同步操作,从而节省了操作时间.如果在此之间有其他线程进行了锁请求,则锁退">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">《深入理解Java虚拟机》笔记04 -- 并发锁</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>Java虚拟机在操作系统层面会先尽一切可能在虚拟机层面上解决竞争关系，尽可能避免真实的竞争发生。同时，在竞争不激烈的场合，也会试图消除不必要的竞争。实现这些手段的方法包括：偏向锁、轻量级锁、自旋锁、锁消除、锁膨胀等</p>
<p>1. 偏向锁</p>
<p>偏向锁是JDK1.6提出的一种锁优化方式。其核心思想是：如果程序没有竞争，则取消之前已经取得锁的线程同步操作。也就是说，若某一锁被线程获取后，便进入偏向模式，当线程再次请求这个锁时，无需再进行相关的同步操作，从而节省了操作时间。如果在此之间有其他线程进行了锁请求，则锁退出偏向模式。在JVM中使用-XX:+UseBiasedLocking 可以设置启用偏向锁。</p>
<p>偏向锁在锁竞争激烈的场合没有太强的优化效果。</p>
<p>2. 轻量级锁</p>
<p>如果偏向锁失败，Java虚拟机会让线程申请轻量级锁。轻量级锁在虚拟机内部，使用一个称为BasicObjecLock的对象实现，这个对象内部由一个BasicLock对象和一个持有该锁的Java对象指针组成。BasicobjectLock对象放置在Java栈的栈帧中。</p>
<p>首先，BasicLock通过set_displaced_header()方法备份了原对象的Mark Word。接着，使用CAS操作，尝试将BasicLock的地址复制到对象头的Mark Word。如果复制 成功，那么加锁成功。如果加锁失败，那么轻量级锁就有可能被膨胀为重量级锁。</p>
<p>3. 锁膨胀</p>
<p>当轻量级锁失败时，就会膨胀成重量级锁。轻量级锁加锁失败后，虚拟机会执行以下操作：1. 废弃前面BasicLock备份的对象头信息。2. 通过inflate()方法进行锁膨胀，其目地是获得对象的ObjectMonitor&nbsp; 3. 使用enter()方法尝试进入锁。</p>
<p>4. 自旋锁</p>
<p>锁膨胀后，进入ObjectMonitor的enter()，纯种很可能会在操作系统层面被挂起，这样线程上下文切换的性能损失就比较大。因此，在锁膨胀之后，虚拟机会做最后的争取，希望线程可以尽快进入临界区而避免被操作系统挂起。一种较为有效的手段就是使用自旋锁。</p>
<p>自旋锁可以使线程在没有取得锁时，不被挂起，而转去执行一个空循环（即所谓的自旋），在若十个空循环后，线程如果可以获得锁，则继续招待。若依然不能获得锁，才会被挂起。不太适用于锁竞争激烈的场合。</p>
<p>在JDK 1.6中，Java虚拟机提供 -XX:+UseSpinning 参数来开户自旋锁，使用 -XX:PreBlockSpin 参数来设置自旋锁的等待次数。</p>
<p>在JDK1.7中，自旋锁参数被取消。自旋锁总是会执行，自旋次数也由虚拟机自行调整。</p>
<p>5. 锁消除</p>
<p>锁消除是Java虚拟机在JIT编译时，对过对运行上下文的扫描，运用逃逸技术，去除不可能存在共享资源竞争的锁。比如：</p>
<pre>public void someBusiness(){
    ......
    StringBuffer sb = new StringBuffer();
    sb.append("XXX");
    ......
}</pre>
<p>StringBuffer中的方法都是有synchronized的，但是这里只是方法内的局部变量，不可能存在锁竞争。</p>
<p>逃逸分析和锁消除分别可以使用参数 -XX:+DoEscapeAnalysis 和 -XX:+EliminateLocks 开启（锁消除必须工作在 -server模式下）</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-15 17:38:36 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/%e5%ad%98%e5%9c%a8/" title="存在">存在</a>, <a href="https://www.biecuoliao.com/tag/str/" title="str">str</a>, <a href="https://www.biecuoliao.com/tag/%e5%9c%b0%e5%9d%80/" title="地址">地址</a>, <a href="https://www.biecuoliao.com/tag/%e4%bf%a1%e6%81%af/" title="信息">信息</a>, <a href="https://www.biecuoliao.com/tag/server/" title="server">server</a>, <a href="https://www.biecuoliao.com/tag/%e5%be%aa%e7%8e%af/" title="循环">循环</a>, <a href="https://www.biecuoliao.com/tag/use/" title="use">use</a>, <a href="https://www.biecuoliao.com/tag/%e5%a4%8d%e5%88%b6/" title="复制">复制</a>, <a href="https://www.biecuoliao.com/tag/%e8%86%a8%e8%83%80/" title="膨胀">膨胀</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>《深入理解Java虚拟机》笔记04 -- 并发锁的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4NAQro3.html" rel="bookmark">深入理解java虚拟机笔记&lpar;一&rpar;－java内存区域与内存溢出</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. 前言 这是深入理解java虚拟机一书的笔记,来自第二章.因为这本书讲的比较深奥,这是第二次看,需要记录一下笔记. 2. 运行时数据区域 java虚拟机所管理的内存分为以下几个区域. ps:图片来自网络 2.1 程序计数器 程序计数器是一块较小的内存空间,他可以看做是当前线程所执行字节码的行号指示器.字节码解释器工作时就是通过改变这个计数器的值来选去下一条要执行的字节码指令,分之.循环.跳转.异常处理.线程恢复等基础功能都需要依赖这个计数器来完成. 这块内存是线程私有的内存. 如果线程在执行			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MBzEmKM.html" rel="bookmark">深入理解Java虚拟机笔记---属性表集合</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在Class文件,字段表,方法表中都可以携带自己的属性表集合,以用于描述某些场景专有的信息.与Class文件中其它的数据项目要求的顺序.长度和内容不同,属性表集合的限制稍微宽松一些,不再要求各个属性表具有严格的顺序,并且只要不与已有的属性名重复,任何人实现的编译器都可以向属性表中写入自己定义的属性信息,Java虚拟机运行时会忽略掉它不认识的属性.为了能正确地解析Class文件,&lt;Java虚拟机规范(第二版)&gt;中预定义了9荐虚拟机实现应当能识别的属性,具体如下表所示: 对于每个属性,它的名称需要			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgmKxO3.html" rel="bookmark">深入理解Java虚拟机笔记---方法调用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				方法调用并不等同于方法执行,方法调用阶段唯一的任务就是确定调用方法的版本(即调用哪一个方法),暂时还不涉及方法内部的具体运行过程.在程序运行时,进行方法调用是最普遍.最频繁的操作.在Class文件的编译过程中不包含传统编译中的连接步骤,一切方法调用在Class文件里存储的都只是符号引用,而不是方法在实际运行时内存布局中的入口地址(相当于直接引用).这个特性给Java带来了更强大的动态扩展能力,但也使得Java方法的调用过程变得相对复杂,需要在类加载期间甚至到运行期间才能确定目标方法的直接引用.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35dBRn0.html" rel="bookmark">深入理解Java虚拟机笔记---垃圾收集器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				如果说收集算法是内存回收的方法论,那么垃圾收集器就是内存回收的具体实现.Java虚拟机规范中对象垃圾收集器应该如何实现并没有任何规定,因此不同的厂商,不同版本的虚拟机所提供的收集器可能会有很的差别,并且一般会提供参数供用户根据自己的应用特点和要求组合出各个年代所使用的收集器.下面是Sun HotSpot虚拟机1.6版本Update22包含的所有收集器: 上图中,如果两个收集器之间存在连线,就说明它们可以搭配使用. 1.Serial收集器 Serial收集器是最基本.历史最悠久的收集器,曾经(在J			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MXq8v80.html" rel="bookmark">深入理解Java虚拟机--笔记1</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java内存区域与内存溢出异常 运行时数据区域 Java虚拟机在执行Java程序的过程中会把它所管理的内存区域划分为若干个不同的数据区域. 1 程序计数器--Program Counter Register 一块较小的内存空间,作用可视为当前线程所执行的字节码的行号指示器,没个线程有自己独立的程序计数器,即&quot;线程私有&quot;的内存区域. 若线程当前执行的是一个Java方法,则这个计数器记录的是当前执行的虚拟机字节码指令的地址: 若线程当前执行的是一个Native方法,则这个计数器值为空(Un			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vDmzXM.html" rel="bookmark">深入理解Java虚拟机笔记---运行时栈帧结构</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				栈帧(Stack Frame)是用于支持虚拟机进行方法调用和方法执行的数据结构,它是虚拟机运行时数据区的虚拟机栈(Virtual Machine Stack)的栈元素.栈帧存储了方法的局部变量表,操作数栈,动态连接和方法返回地址等信息.第一个方法从调用开始到执行完成,就对应着一个栈帧在虚拟机栈中从入栈到出栈的过程. 每一个栈帧都包括了局部变量表,操作数栈,动态连接,方法返回地址和一些额外的附加信息.在编译代码的时候,栈帧中需要多大的局部变量表,多深的操作数栈都已经完全确定了,并且写入到了方法表的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/02g5zE3.html" rel="bookmark">深入理解Java虚拟机笔记---内存区域</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java虚拟机在执行Java程序过程中会把它所管理的内存划分为若干个不同的数据区域.这些区域有自各的用途,以及创建及销毁时间,有的区域随着虚拟机进程的启动而存在,有些区域则是依赖用户线程的启动和结束而建立和销毁.根据&lt;Java虚拟机规范(第2版)&gt;规定,Java虚拟机管理的内存区域包括以下几个运行时数据区域,下如图 1.程序计数器(Program Counter Register) 程序计数器是一块较小的内存空间,它的作用可以看做是当前线程所执行的字节码的行号指示器.字节码解释器工作时就是通过			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MXrrJ83.html" rel="bookmark">深入理解Java虚拟机笔记---class类文件结构概述</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				class文件是一组以8位字节为基础单位的二进制流,各个数据项目严格紧凑地排列在class文件中,中间没有任何分隔符.当遇到需要占用8位字节以上的的数据项时,则会按照高位在前的方式侵害成若干个8位字节进行存储. 根据Java虚拟机规范的规定,class文件格式采用一种类似于C语言结构体的伪结构来存储,这种伪结构只有两种数据类型:无符号数和表.无符号数属于基于数据类型,以u1.u2.u4.u8来分别代码1个字节.2个字节.4个字节.8个字节的无符号数,无符号数可以用于描述数字.索引引用.数量值,或			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MV9vE24.html" rel="bookmark">深入理解Java虚拟机笔记&mdash;&mdash;虚拟机类加载机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				[TOC] 概述 虚拟机把描述类的数据从Class文件加载到内存,并对数据进行校验.转换解析和初始化,最终形成可以被虚拟机直接使用的Java类型,这就是虚拟机的类加载机制. 动态加载和动态连接 在Java语言里面,类型的加载.连接和初始化过程都是在程序运行期间完成的. 类加载的时机 类的生命周期 类从被加载到虚拟机内存中开始,到卸载出内存位置,它的整个生命周期包括: 加载(Loading).验证(Verification).准备(Preparing).解析(Resolution).初始化(Ini			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/kMLqGE0.html" rel="bookmark" class="title">谭浩强 c程序设计 8&period;17用递归法将一个整数n转换成字符串。例如，输入486，应输出字符串&amp;quot&semi;486&amp;quot&semi;。n的位数不确定，可以是任意位数的整数。</a>
					<div>
						8.17用递归法将一个整数n转换成字符串.例如,输入486,应输出字符串&quot;486&quot;.n的位数不确定,可以是任意位数的整数. #include &lt;stdio.h&gt; cha ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0Kanz94.html" rel="bookmark" class="title">jdbc零散知识点</a>
					<div>
						1.可滚动结果集: 1 conn = JdbcUtils.getConnection(); 2 st = conn.createStatement(ResultSet.TYPE_SCROLL_SENS ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41gDmY0.html" rel="bookmark" class="title">洛谷P1428小鱼比可爱</a>
					<div>
						#include&lt;bits/stdc++.h&gt;using namespace std;int a[101],b[101],n;int main(){ cin&gt;&gt;n; for ( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38ZYGyM.html" rel="bookmark" class="title">计算四则运算表达式</a>
					<div>
						#token.h# #ifndef TOKEN_H_INCLUDED #define TOKEN_H_INCLUDED typedef enum { BAD_TOKEN, NUMBER_TOKEN,  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3O7zyr3.html" rel="bookmark" class="title">免费素材：25套免费的 Web UI 设计的界面元素&lpar;转&rpar;</a>
					<div>
						Web 元素是任何网站相关项目都需要的,质量和良好设计的元素对于设计师来说就像宝贝一样.如果您正在为您的网站,博客,Web 应用程序或移动应用程序寻找完美设计的网页元素,那么下面这个列表会是你需要的. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Q8XWo3.html" rel="bookmark" class="title">【坐在马桶上看算法】算法11：堆&mdash;&mdash;神奇的优先队列（上）</a>
					<div>
						堆是什么?是一种特殊的完全二叉树,就像下面这棵树一样. 有没有发现这棵二叉树有一个特点,就是所有父结点都比子结点要小(注意:圆圈里面的数是值,圆圈上面的数是这个结点的编号,此规定仅适用于本节).符合这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Myjppp0.html" rel="bookmark" class="title">【嵌入式4412开发板学习教程】Uboot教程之uboot基础概念和框架</a>
					<div>
						[4412开发板教程]Uboot教程之uboot基础概念和框架 正在学习uboot,教程讲解的很详细,先上个笔记,视频上传到网盘后再补上...... 知识点: 1.操作系统分层的概念 Windows: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/ME8nBD4.html" rel="bookmark" class="title">Linux autojump命令</a>
					<div>
						一.简介 autojump是一个命令行工具,它允许你可以直接跳转到你喜爱的目录,而不用管你现在身在何处. 二.安装 yum install autojump 三.用法 j [目录的名字或名字的一部分] ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/352jbE4.html" rel="bookmark" class="title">通用的生活购物类商城静态模板</a>
					<div>
						链接:http://pan.baidu.com/s/1kUSwvJp 密码:ztg8					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0d9aJz3.html" rel="bookmark" class="title">Linux命令（2）- mv</a>
					<div>
						mv 功能:可以用来移动文件或者将文件改名. 格式:mv [选项] 源文件或目录 目标文件或目录 说明:mv命令将文件重命名或将其移至一个新的目录中.第二个参数类型是文件时,mv命令完成文件重命名,此 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0R7BJY3.html" rel="bookmark" class="title">回顾&amp;lt&semi;Video Timing Controller v6&period;1&amp;gt&semi;</a>
					<div>
						VTC总体架构图: 对于最基本的功能:视频时序产生					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lkryoM.html" rel="bookmark" class="title">iOS &lowbar;&lowbar;block变量作用域</a>
					<div>
						看下图 在c语言中,2个独立的函数是不可能互相访问局部变量的(inline?)但是block提供了这个功能,它不但能读变量,还可以对变量进行写!上图说明,block获得了i最后的真实值5,没有只取得0 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mgl95K0.html" rel="bookmark" class="title">Linux环境用shell调用Dubbo服务</a>
					<div>
						因项目中遇到非Dubbo框架的系统需要调度Dubbo框架系统的任务. 尝试了用expect方法,需要Linux安装tcl和expect. 首先Dubbo官方文档中有提到Linux调用Dubbo的方式  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nLb5N4.html" rel="bookmark" class="title">GPT与MBR分区</a>
					<div>
						今天在测试机器上安装win7,遇到问题.最初使用PE下进行原版安装,使用install.vim安装.安装过程显示正常,并无报错. 重启,无法进入系统,显示报错信息为: none was found l ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AWo7g0.html" rel="bookmark" class="title">CentOS安装Redis记录</a>
					<div>
						redis 是一个基于内存的高性能key-value数据库,数据都保存在内存中定期刷新到磁盘,以极高的读写效率而备受关注.他的特点是支持各种数据结构,stirng,hashes, list,set,和 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/351JYR3.html" rel="bookmark" class="title">Cocos2d-x Lua中网格动作</a>
					<div>
						Cocos2d-x Lua中网格动作 GridAction它有两个主要的子类Grid3DAction和TiledGrid3DAction,TiledGrid3DAction系列的子类中会有瓦片效果,如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wpNaV4.html" rel="bookmark" class="title">&lbrack;029&rsqb; 微信公众帐号开发教程第5篇-各种消息的接收与响应</a>
					<div>
						前一篇文章里我们已经把微信公众平台接口中消息及相关操作都进行了封装,本章节将主要介绍如何接收微信服务器发送的消息并做出响应. 明确在哪接收消息 从微信公众平台接口消息指南中可以了解到,当用户向公众帐号 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0n7AqV3.html" rel="bookmark" class="title">html css 多级菜单实例</a>
					<div>
						&lt;!DOCTYPE html PUBLIC &quot;-//W3C//DTD XHTML 1.0 Transitional//EN&quot; &quot;http://www.w3.org/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pGrDy3.html" rel="bookmark" class="title">UVA 1500 - Alice and Bob&lpar;博弈&rpar;</a>
					<div>
						UVA 1500 - Alice and Bob 题目链接 题意:alice和bob这对狗男女play a game,黑板上有n个数字,每次能把一个数字减1,或者把两个数字合成一个数字,值为两数的和, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPOJn64.html" rel="bookmark" class="title">&lbrack;jzoj5073 GDOI2017第二轮模拟&rsqb; 影魔</a>
					<div>
						Description 影魔,奈文摩尔,据说有着一个诗人的灵魂.事实上,他吞噬的诗人灵魂早已成千上万.千百年来,他收集了各式各样的灵魂,包括诗人.牧师.帝王.乞丐.奴隶.罪人,当然,还有英雄.每一个灵 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
